* [PATCH v5] scripts/config: honor $KBUILD_OUTPUT by default
@ 2026-10-02 22:21 Dmitry Voytik
0 siblings, 0 replies; only message in thread
From: Dmitry Voytik @ 2026-10-02 22:21 UTC (permalink / raw)
To: Nicolas Schier, Nathan Chancellor
Cc: Nicolas Schier, Rong Zhang, linux-kernel, linux-kbuild, Dmitry Voytik
If $KBUILD_OUTPUT is set, use it by default if --file is not passed.
Fix the issue when the script silently updates a stale .config in
the root directory, while the user expects ${KBUILD_OUTPUT}/.config
to be updated.
Handle properly if the config file is a relative path.
The problem can be worked around with --file, but this is easy to miss,
and is inconsistent with how the Makefile and other tools work
(e.g., scripts/diffconfig).
How to reproduce the issue:
rm .config
export KBUILD_OUTPUT=.out
make defconfig
./scripts/config \
-e CONFIG_UBSAN
grep: .config: No such file or directory
How the patch was tested:
make mrproper
export KBUILD_OUTPUT=.out
make defconfig
grep "CONFIG_UBSAN=y" $KBUILD_OUTPUT/.config || echo "OK"
Test the basic usage:
./scripts/config -e CONFIG_UBSAN
grep "CONFIG_UBSAN=y" $KBUILD_OUTPUT/.config && echo "OK"
Test --refresh picks up correct config file by using $KBUILD_OUTPUT:
./scripts/config -d CONFIG_UBSAN
./scripts/config --refresh -e CONFIG_UBSAN
grep "CONFIG_UBSAN=y" $KBUILD_OUTPUT/.config && echo "OK"
Test --file takes precedence over $KBUILD_OUTPUT and a relative
path is handled properly:
./scripts/config -d CONFIG_UBSAN
mkdir .out2
cp .out/.config .out2/.my_config
grep "CONFIG_UBSAN=y" .out2/.my_config
./scripts/config --file .out2/.my_config --refresh \
-e CONFIG_UBSAN
grep "CONFIG_UBSAN=y" .out2/.my_config && echo "OK"
ls .out/.out2 || echo "OK"
ls .out/.out || echo "OK"
Test --file can accept files with hyphen:
./scripts/config -d CONFIG_UBSAN
cp .out/.config -- -my_config
grep "CONFIG_UBSAN=y" -- -my_config || echo "OK"
./scripts/config --refresh \
-e CONFIG_UBSAN --file -my_config
grep "CONFIG_UBSAN=y" -- -my_config && echo "OK"
Signed-off-by: Dmitry Voytik <voytikd@gmail.com>
---
v5:
- Per Nathan Chancellor's suggestion, improved handling $FN path by
realpath
- https://lore.kernel.org/lkml/179097210878.309835.10523307262544578337.b4-review@b4/
- Documented the new test scenario in the git commit message
v4:
- Addressed Nicolas Schier's comments - dropped the change how '--refresh'
is handled
- Implemented conversion of $FN to the absolute path which helps with
'--refresh' and relative paths
- Documented testing steps in the commit message
v3:
- Added an example in the commit message how to reproduce the issue
v2:
- Addressed comments by sashiko:
- https://sashiko.dev/#/patchset/20260920064350.17999-1-voytikd%40gmail.com
- use basename when --refresh is used
- remove echo which can be misleading when --file is passed
v1:
- https://lore.kernel.org/all/20260920064350.17999-1-voytikd@gmail.com/
---
scripts/config | 5 +++++
1 file changed, 5 insertions(+)
diff --git a/scripts/config b/scripts/config
index 32428ea909c2..7e84c3d4e621 100755
--- a/scripts/config
+++ b/scripts/config
@@ -130,6 +130,10 @@ on_exit() {
trap on_exit EXIT
FN=.config
+if [ -n "${KBUILD_OUTPUT}" ]; then
+ FN=${KBUILD_OUTPUT}/${FN}
+fi
+
CMDS=()
while [[ $# -gt 0 ]]; do
if [ "$1" = "--file" ]; then
@@ -143,6 +147,7 @@ while [[ $# -gt 0 ]]; do
shift
fi
done
+FN=$(realpath -q -- "$FN" || echo "$FN")
set -- "${CMDS[@]}"
if [ "$1" = "" ] ; then
--
2.55.0
^ permalink raw reply [flat|nested] only message in thread
only message in thread, other threads:[~2026-10-02 22:22 UTC | newest]
Thread overview: (only message) (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2026-10-02 22:21 [PATCH v5] scripts/config: honor $KBUILD_OUTPUT by default Dmitry Voytik
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox
all inboxes | Powered by JetHome®